diff --git a/gdb/syscalls/amd64-linux.xml.in b/gdb/syscalls/amd64-linux.xml.in
index bc1e5772b06..89c5f700157 100644
--- a/gdb/syscalls/amd64-linux.xml.in
+++ b/gdb/syscalls/amd64-linux.xml.in
@@ -377,4 +377,15 @@
   <syscall name="process_mrelease" number="448"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450"/>
+  <syscall name="cachestat" number="451"/>
+  <syscall name="fchmodat2" number="452"/>
+  <syscall name="map_shadow_stack" number="453"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/i386-linux.xml.in b/gdb/syscalls/i386-linux.xml.in
index edf916f4dae..46916d5868b 100644
--- a/gdb/syscalls/i386-linux.xml.in
+++ b/gdb/syscalls/i386-linux.xml.in
@@ -455,4 +455,15 @@
   <syscall name="process_mrelease" number="448"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450"/>
+  <syscall name="cachestat" number="451"/>
+  <syscall name="fchmodat2" number="452"/>
+  <syscall name="map_shadow_stack" number="453"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/mips-n32-linux.xml.in b/gdb/syscalls/mips-n32-linux.xml.in
index 22245476089..11ca265b99b 100644
--- a/gdb/syscalls/mips-n32-linux.xml.in
+++ b/gdb/syscalls/mips-n32-linux.xml.in
@@ -391,4 +391,15 @@
   <syscall name="process_mrelease" number="6448"/>
   <syscall name="futex_waitv" number="6449"/>
   <syscall name="set_mempolicy_home_node" number="6450"/>
+  <syscall name="cachestat" number="6451"/>
+  <syscall name="fchmodat2" number="6452"/>
+  <syscall name="map_shadow_stack" number="6453"/>
+  <syscall name="futex_wake" number="6454"/>
+  <syscall name="futex_wait" number="6455"/>
+  <syscall name="futex_requeue" number="6456"/>
+  <syscall name="statmount" number="6457"/>
+  <syscall name="listmount" number="6458"/>
+  <syscall name="lsm_get_self_attr" number="6459"/>
+  <syscall name="lsm_set_self_attr" number="6460"/>
+  <syscall name="lsm_list_modules" number="6461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/mips-n64-linux.xml.in b/gdb/syscalls/mips-n64-linux.xml.in
index 4ad837357b1..f0a9da22133 100644
--- a/gdb/syscalls/mips-n64-linux.xml.in
+++ b/gdb/syscalls/mips-n64-linux.xml.in
@@ -366,4 +366,15 @@
   <syscall name="landlock_restrict_self" number="5446"/>
   <syscall name="process_mrelease" number="5448"/>
   <syscall name="futex_waitv" number="5449"/>
+  <syscall name="cachestat" number="5451"/>
+  <syscall name="fchmodat2" number="5452"/>
+  <syscall name="map_shadow_stack" number="5453"/>
+  <syscall name="futex_wake" number="5454"/>
+  <syscall name="futex_wait" number="5455"/>
+  <syscall name="futex_requeue" number="5456"/>
+  <syscall name="statmount" number="5457"/>
+  <syscall name="listmount" number="5458"/>
+  <syscall name="lsm_get_self_attr" number="5459"/>
+  <syscall name="lsm_set_self_attr" number="5460"/>
+  <syscall name="lsm_list_modules" number="5461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/mips-o32-linux.xml.in b/gdb/syscalls/mips-o32-linux.xml.in
index 7c3eda13c54..553187ef69d 100644
--- a/gdb/syscalls/mips-o32-linux.xml.in
+++ b/gdb/syscalls/mips-o32-linux.xml.in
@@ -431,4 +431,15 @@
   <syscall name="process_mrelease" number="4448"/>
   <syscall name="futex_waitv" number="4449"/>
   <syscall name="set_mempolicy_home_node" number="4450"/>
+  <syscall name="cachestat" number="4451"/>
+  <syscall name="fchmodat2" number="4452"/>
+  <syscall name="map_shadow_stack" number="4453"/>
+  <syscall name="futex_wake" number="4454"/>
+  <syscall name="futex_wait" number="4455"/>
+  <syscall name="futex_requeue" number="4456"/>
+  <syscall name="statmount" number="4457"/>
+  <syscall name="listmount" number="4458"/>
+  <syscall name="lsm_get_self_attr" number="4459"/>
+  <syscall name="lsm_set_self_attr" number="4460"/>
+  <syscall name="lsm_list_modules" number="4461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/ppc-linux.xml.in b/gdb/syscalls/ppc-linux.xml.in
index 2ca043b0918..51776a66a35 100644
--- a/gdb/syscalls/ppc-linux.xml.in
+++ b/gdb/syscalls/ppc-linux.xml.in
@@ -446,4 +446,15 @@
   <syscall name="process_mrelease" number="448"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450"/>
+  <syscall name="cachestat" number="451"/>
+  <syscall name="fchmodat2" number="452"/>
+  <syscall name="map_shadow_stack" number="453"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/ppc64-linux.xml.in b/gdb/syscalls/ppc64-linux.xml.in
index b65c6968421..9554002c595 100644
--- a/gdb/syscalls/ppc64-linux.xml.in
+++ b/gdb/syscalls/ppc64-linux.xml.in
@@ -418,4 +418,15 @@
   <syscall name="process_mrelease" number="448"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450"/>
+  <syscall name="cachestat" number="451"/>
+  <syscall name="fchmodat2" number="452"/>
+  <syscall name="map_shadow_stack" number="453"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/s390-linux.xml.in b/gdb/syscalls/s390-linux.xml.in
index 2051fc224a3..371c0a0220f 100644
--- a/gdb/syscalls/s390-linux.xml.in
+++ b/gdb/syscalls/s390-linux.xml.in
@@ -432,7 +432,19 @@
   <syscall name="landlock_create_ruleset" number="444"/>
   <syscall name="landlock_add_rule" number="445"/>
   <syscall name="landlock_restrict_self" number="446"/>
+  <syscall name="memfd_secret" number="447"/>
   <syscall name="process_mrelease" number="448"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450"/>
+  <syscall name="cachestat" number="451"/>
+  <syscall name="fchmodat2" number="452"/>
+  <syscall name="map_shadow_stack" number="453"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/s390x-linux.xml.in b/gdb/syscalls/s390x-linux.xml.in
index 43c25b97191..578e79e9d36 100644
--- a/gdb/syscalls/s390x-linux.xml.in
+++ b/gdb/syscalls/s390x-linux.xml.in
@@ -380,7 +380,19 @@
   <syscall name="landlock_create_ruleset" number="444"/>
   <syscall name="landlock_add_rule" number="445"/>
   <syscall name="landlock_restrict_self" number="446"/>
+  <syscall name="memfd_secret" number="447"/>
   <syscall name="process_mrelease" number="448"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450"/>
+  <syscall name="cachestat" number="451"/>
+  <syscall name="fchmodat2" number="452"/>
+  <syscall name="map_shadow_stack" number="453"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/sparc-linux.xml.in b/gdb/syscalls/sparc-linux.xml.in
index 9b479544759..12e08bfbf8b 100644
--- a/gdb/syscalls/sparc-linux.xml.in
+++ b/gdb/syscalls/sparc-linux.xml.in
@@ -434,4 +434,15 @@
   <syscall name="process_mrelease" number="448"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450"/>
+  <syscall name="cachestat" number="451"/>
+  <syscall name="fchmodat2" number="452"/>
+  <syscall name="map_shadow_stack" number="453"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/sparc64-linux.xml.in b/gdb/syscalls/sparc64-linux.xml.in
index 457467b22ff..77560ddc150 100644
--- a/gdb/syscalls/sparc64-linux.xml.in
+++ b/gdb/syscalls/sparc64-linux.xml.in
@@ -397,4 +397,15 @@
   <syscall name="process_mrelease" number="448"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450"/>
+  <syscall name="cachestat" number="451"/>
+  <syscall name="fchmodat2" number="452"/>
+  <syscall name="map_shadow_stack" number="453"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>