diff --git a/gdb/syscalls/amd64-linux.xml b/gdb/syscalls/amd64-linux.xml
index 8f93b9a58bb..ddc0b37f3f7 100644
--- a/gdb/syscalls/amd64-linux.xml
+++ b/gdb/syscalls/amd64-linux.xml
@@ -373,4 +373,15 @@
   <syscall name="process_mrelease" number="448" groups="descriptor"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450" groups="memory"/>
+  <syscall name="cachestat" number="451" groups="descriptor"/>
+  <syscall name="fchmodat2" number="452" groups="descriptor,file"/>
+  <syscall name="map_shadow_stack" number="453" groups="memory"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/i386-linux.xml b/gdb/syscalls/i386-linux.xml
index 9b1db803720..531bf73da45 100644
--- a/gdb/syscalls/i386-linux.xml
+++ b/gdb/syscalls/i386-linux.xml
@@ -451,4 +451,15 @@
   <syscall name="process_mrelease" number="448" groups="descriptor"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450" groups="memory"/>
+  <syscall name="cachestat" number="451" groups="descriptor"/>
+  <syscall name="fchmodat2" number="452" groups="descriptor,file"/>
+  <syscall name="map_shadow_stack" number="453" groups="memory"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/mips-n32-linux.xml b/gdb/syscalls/mips-n32-linux.xml
index e382f0a96bf..911cb4158ef 100644
--- a/gdb/syscalls/mips-n32-linux.xml
+++ b/gdb/syscalls/mips-n32-linux.xml
@@ -387,4 +387,15 @@
   <syscall name="process_mrelease" number="6448" groups="descriptor"/>
   <syscall name="futex_waitv" number="6449"/>
   <syscall name="set_mempolicy_home_node" number="6450" groups="memory"/>
+  <syscall name="cachestat" number="6451" groups="descriptor"/>
+  <syscall name="fchmodat2" number="6452" groups="descriptor,file"/>
+  <syscall name="map_shadow_stack" number="6453" groups="memory"/>
+  <syscall name="futex_wake" number="6454"/>
+  <syscall name="futex_wait" number="6455"/>
+  <syscall name="futex_requeue" number="6456"/>
+  <syscall name="statmount" number="6457"/>
+  <syscall name="listmount" number="6458"/>
+  <syscall name="lsm_get_self_attr" number="6459"/>
+  <syscall name="lsm_set_self_attr" number="6460"/>
+  <syscall name="lsm_list_modules" number="6461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/mips-n64-linux.xml b/gdb/syscalls/mips-n64-linux.xml
index 56ccc1aabc3..858a42333e7 100644
--- a/gdb/syscalls/mips-n64-linux.xml
+++ b/gdb/syscalls/mips-n64-linux.xml
@@ -362,4 +362,15 @@
   <syscall name="landlock_restrict_self" number="5446" groups="descriptor"/>
   <syscall name="process_mrelease" number="5448" groups="descriptor"/>
   <syscall name="futex_waitv" number="5449"/>
+  <syscall name="cachestat" number="5451" groups="descriptor"/>
+  <syscall name="fchmodat2" number="5452" groups="descriptor,file"/>
+  <syscall name="map_shadow_stack" number="5453" groups="memory"/>
+  <syscall name="futex_wake" number="5454"/>
+  <syscall name="futex_wait" number="5455"/>
+  <syscall name="futex_requeue" number="5456"/>
+  <syscall name="statmount" number="5457"/>
+  <syscall name="listmount" number="5458"/>
+  <syscall name="lsm_get_self_attr" number="5459"/>
+  <syscall name="lsm_set_self_attr" number="5460"/>
+  <syscall name="lsm_list_modules" number="5461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/mips-o32-linux.xml b/gdb/syscalls/mips-o32-linux.xml
index 4c46bf8ee57..345d2201003 100644
--- a/gdb/syscalls/mips-o32-linux.xml
+++ b/gdb/syscalls/mips-o32-linux.xml
@@ -427,4 +427,15 @@
   <syscall name="process_mrelease" number="4448" groups="descriptor"/>
   <syscall name="futex_waitv" number="4449"/>
   <syscall name="set_mempolicy_home_node" number="4450" groups="memory"/>
+  <syscall name="cachestat" number="4451" groups="descriptor"/>
+  <syscall name="fchmodat2" number="4452" groups="descriptor,file"/>
+  <syscall name="map_shadow_stack" number="4453" groups="memory"/>
+  <syscall name="futex_wake" number="4454"/>
+  <syscall name="futex_wait" number="4455"/>
+  <syscall name="futex_requeue" number="4456"/>
+  <syscall name="statmount" number="4457"/>
+  <syscall name="listmount" number="4458"/>
+  <syscall name="lsm_get_self_attr" number="4459"/>
+  <syscall name="lsm_set_self_attr" number="4460"/>
+  <syscall name="lsm_list_modules" number="4461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/ppc-linux.xml b/gdb/syscalls/ppc-linux.xml
index ac0c4e2f24e..0a3131407db 100644
--- a/gdb/syscalls/ppc-linux.xml
+++ b/gdb/syscalls/ppc-linux.xml
@@ -442,4 +442,15 @@
   <syscall name="process_mrelease" number="448" groups="descriptor"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450" groups="memory"/>
+  <syscall name="cachestat" number="451" groups="descriptor"/>
+  <syscall name="fchmodat2" number="452" groups="descriptor,file"/>
+  <syscall name="map_shadow_stack" number="453" groups="memory"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/ppc64-linux.xml b/gdb/syscalls/ppc64-linux.xml
index 33642f82fbc..99435187098 100644
--- a/gdb/syscalls/ppc64-linux.xml
+++ b/gdb/syscalls/ppc64-linux.xml
@@ -414,4 +414,15 @@
   <syscall name="process_mrelease" number="448" groups="descriptor"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450" groups="memory"/>
+  <syscall name="cachestat" number="451" groups="descriptor"/>
+  <syscall name="fchmodat2" number="452" groups="descriptor,file"/>
+  <syscall name="map_shadow_stack" number="453" groups="memory"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/s390-linux.xml b/gdb/syscalls/s390-linux.xml
index 8c749edd9cb..9c2933284a3 100644
--- a/gdb/syscalls/s390-linux.xml
+++ b/gdb/syscalls/s390-linux.xml
@@ -428,7 +428,19 @@
   <syscall name="landlock_create_ruleset" number="444" groups="descriptor"/>
   <syscall name="landlock_add_rule" number="445" groups="descriptor"/>
   <syscall name="landlock_restrict_self" number="446" groups="descriptor"/>
+  <syscall name="memfd_secret" number="447" groups="descriptor"/>
   <syscall name="process_mrelease" number="448" groups="descriptor"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450" groups="memory"/>
+  <syscall name="cachestat" number="451" groups="descriptor"/>
+  <syscall name="fchmodat2" number="452" groups="descriptor,file"/>
+  <syscall name="map_shadow_stack" number="453" groups="memory"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/s390x-linux.xml b/gdb/syscalls/s390x-linux.xml
index 63ac49d96e5..d3da20f9300 100644
--- a/gdb/syscalls/s390x-linux.xml
+++ b/gdb/syscalls/s390x-linux.xml
@@ -376,7 +376,19 @@
   <syscall name="landlock_create_ruleset" number="444" groups="descriptor"/>
   <syscall name="landlock_add_rule" number="445" groups="descriptor"/>
   <syscall name="landlock_restrict_self" number="446" groups="descriptor"/>
+  <syscall name="memfd_secret" number="447" groups="descriptor"/>
   <syscall name="process_mrelease" number="448" groups="descriptor"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450" groups="memory"/>
+  <syscall name="cachestat" number="451" groups="descriptor"/>
+  <syscall name="fchmodat2" number="452" groups="descriptor,file"/>
+  <syscall name="map_shadow_stack" number="453" groups="memory"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/sparc-linux.xml b/gdb/syscalls/sparc-linux.xml
index 310f30b2cb9..cc2971bb2a7 100644
--- a/gdb/syscalls/sparc-linux.xml
+++ b/gdb/syscalls/sparc-linux.xml
@@ -430,4 +430,15 @@
   <syscall name="process_mrelease" number="448" groups="descriptor"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450" groups="memory"/>
+  <syscall name="cachestat" number="451" groups="descriptor"/>
+  <syscall name="fchmodat2" number="452" groups="descriptor,file"/>
+  <syscall name="map_shadow_stack" number="453" groups="memory"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>
diff --git a/gdb/syscalls/sparc64-linux.xml b/gdb/syscalls/sparc64-linux.xml
index 93430503572..f69dd9f0245 100644
--- a/gdb/syscalls/sparc64-linux.xml
+++ b/gdb/syscalls/sparc64-linux.xml
@@ -393,4 +393,15 @@
   <syscall name="process_mrelease" number="448" groups="descriptor"/>
   <syscall name="futex_waitv" number="449"/>
   <syscall name="set_mempolicy_home_node" number="450" groups="memory"/>
+  <syscall name="cachestat" number="451" groups="descriptor"/>
+  <syscall name="fchmodat2" number="452" groups="descriptor,file"/>
+  <syscall name="map_shadow_stack" number="453" groups="memory"/>
+  <syscall name="futex_wake" number="454"/>
+  <syscall name="futex_wait" number="455"/>
+  <syscall name="futex_requeue" number="456"/>
+  <syscall name="statmount" number="457"/>
+  <syscall name="listmount" number="458"/>
+  <syscall name="lsm_get_self_attr" number="459"/>
+  <syscall name="lsm_set_self_attr" number="460"/>
+  <syscall name="lsm_list_modules" number="461"/>
 </syscalls_info>