diff --git a/gdb/testsuite/gdb.dwarf2/locexpr-data-member-dynamic-location.c b/gdb/testsuite/gdb.dwarf2/locexpr-data-member-dynamic-location.c
new file mode 100644
index 00000000000..dbe591ab884
--- /dev/null
+++ b/gdb/testsuite/gdb.dwarf2/locexpr-data-member-dynamic-location.c
@@ -0,0 +1,32 @@
+/* Copyright 2024 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+struct container
+{
+  int *data;
+};
+
+int size = 5;
+
+int var_a_data[] = {5, 8, 13, 21, 34};
+struct container var_a = {var_a_data};
+
+int
+main (void)
+{
+  return 0;
+}
diff --git a/gdb/testsuite/gdb.dwarf2/locexpr-data-member-dynamic-location.exp b/gdb/testsuite/gdb.dwarf2/locexpr-data-member-dynamic-location.exp
new file mode 100644
index 00000000000..1dd2e91ffdd
--- /dev/null
+++ b/gdb/testsuite/gdb.dwarf2/locexpr-data-member-dynamic-location.exp
@@ -0,0 +1,129 @@
+# Copyright 2024 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+# Tests that GDB prints an error when fetching a value's (dynamic) field
+# with unresolved data location.  For a reproducer, we setup the following
+# struct type:
+#
+#   struct container
+#     {
+#       int *data;
+#     };
+#
+# We use a variable 'size' to define the upper bound 'DW_AT_upper_bound' for
+# the non-static field 'data'.  The error reproduces with invalid DWARF, i.e.
+# when pushing the memory location of an instance 'var_a' of struct
+# 'container' on the DWARF stack:
+#
+#   DW_AT_location {
+#     DW_OP_addr [gdb_target_symbol var_a]
+#     DW_OP_deref
+#     DW_OP_stack_value
+#   } SPECIAL_expr}
+
+load_lib dwarf.exp
+
+# This test can only be run on targets which support DWARF-2 and use gas.
+if {![dwarf2_support]} {
+    return 0
+}
+
+standard_testfile .c -dw.S
+
+if { [prepare_for_testing "failed to prepare" ${testfile} ${srcfile}] } {
+    return -1
+}
+
+# Make some DWARF for the test.
+set asm_file [standard_output_file $srcfile2]
+Dwarf::assemble $asm_file {
+    cu {} {
+	DW_TAG_compile_unit {} {
+	    declare_labels integer_label array_label struct_label var_a_label
+	    set int_size [get_sizeof "int" 4]
+	    set addr_size [get_sizeof "void *" 8]
+
+	    integer_label: DW_TAG_base_type {
+		{DW_AT_byte_size $int_size DW_FORM_sdata}
+		{DW_AT_encoding  @DW_ATE_signed}
+	    }
+
+	    array_label: DW_TAG_array_type {
+		{DW_AT_type :$integer_label}
+		{DW_AT_data_location {
+		    DW_OP_push_object_address
+		    DW_OP_deref
+		} SPECIAL_expr}
+	    } {
+		DW_TAG_subrange_type {
+		    {DW_AT_type :$integer_label}
+		    {DW_AT_upper_bound {
+			DW_OP_addr [gdb_target_symbol size]
+			DW_OP_deref
+			DW_OP_lit1
+			DW_OP_minus
+		    } SPECIAL_expr}
+		}
+	    }
+
+	    struct_label: DW_TAG_structure_type {
+		{DW_AT_byte_size 8 DW_FORM_udata}
+	    } {
+		DW_TAG_member {
+		    {DW_AT_name "data"}
+		    {DW_AT_type :${array_label}}
+		    {DW_AT_data_member_location 0 DW_FORM_udata}
+		}
+	    }
+
+	    DW_TAG_variable {
+		{DW_AT_name var_a_valid_location}
+		{DW_AT_type :$struct_label}
+		{DW_AT_location {
+		    DW_OP_addr [gdb_target_symbol var_a]
+		} SPECIAL_expr}
+	    }
+
+	    DW_TAG_variable {
+		{DW_AT_name var_a_invalid_location}
+		{DW_AT_type :$struct_label}
+		{DW_AT_location {
+		    DW_OP_addr [gdb_target_symbol var_a]
+		    DW_OP_deref
+		    DW_OP_stack_value
+		} SPECIAL_expr}
+	    }
+	}
+    }
+}
+
+# Now that we've generated the DWARF debugging info, rebuild our
+# program using our debug info instead of the info generated by
+# the compiler.
+
+if { [prepare_for_testing "failed to prepare" ${testfile} \
+	  [list $srcfile $asm_file] {nodebug}] } {
+    return -1
+}
+
+if ![runto_main] {
+    return -1
+}
+
+gdb_test "print var_a_valid_location" \
+	 " = \\{data = \\{5, 8, 13, 21, 34\\}\\}"
+
+gdb_test "print var_a_invalid_location" \
+	 " = \\{data = <error reading variable: cannot read data.*"
diff --git a/gdb/value.c b/gdb/value.c
index a2b2721d183..145e70074a9 100644
--- a/gdb/value.c
+++ b/gdb/value.c
@@ -3060,7 +3060,9 @@ value::primitive_field (LONGEST offset, int fieldno, struct type *arg_type)
 
       gdb_assert (0 == offset);
       /* We expect an already resolved data location.  */
-      gdb_assert (TYPE_DATA_LOCATION (type)->is_constant ());
+      if (!TYPE_DATA_LOCATION (type)->is_constant ())
+	error (_("cannot read %s, expected an already resolved data "
+		 "location."), arg_type->field (fieldno).name ());
       /* For dynamic data types defer memory allocation
 	 until we actual access the value.  */
       v = value::allocate_lazy (type);